/**************************************************************
parse.h Command parser variables and functions

    H8 Debug/Monitor port Command processing

    Date    9/6/98

    Author  Paul Carpenter

***************************************************************/
/**************** Global Variables  ***************************/
extern BYTE     paramc;
extern int      loop;
extern int      error;
extern char     *paramv[ 16 ];
extern union temp_val
            {
            unsigned char   ch;
            short         word;
            }   temp_numb[ 6 ];

extern unsigned long temp_addr[ 3 ];
extern unsigned long number;

/****************** Prototypes *********************************/
extern void    param_error( unsigned int );
extern int     conv_byte( int, BYTE, BYTE, BYTE );
extern int     conv_word( int, int, int, int );
extern int     conv_address( int );
extern int     parse_command( void );
extern void    clear_command( void );
extern char   *conv_number( char *, unsigned long * );
extern int     comm_byte( int );
extern int     comm_bin( int );

extern struct comm_table
        {
        char            *token;
        unsigned char   min_arg;
        unsigned char   max_arg;
        unsigned char   modes;
        int             (*func)( void );
        } commands[ NO_COMMANDS ];
