; reads analog value on [2-13]=AD1 and outputs on DA1=[2-19]
	.h8300h
; .section .start
	.align 1
	.global _start

_start:
       mov.l   #0xffefc,er7		; =mov.l ...,sp : set stack pointer
       ldc.b   #0xc0,  ccr             ; disable interrupt
       mov.b   #0x00,  r0l             ; 2-State Access(All area)
       mov.b   r0l,	@0xffffed

       mov.b   #0xff,r0l  		; set P5 as output
       mov.b   r0l,@0xfffc8 		; |

; D/A: fffdc=D/A data 0 ; fffdd=D/A data 1 ; fffde=D/A ctrl ; fff5c=D/Astdby
	bset	#0x5,@0xfffde:8	; D/A enable
	bset	#0x7,@0xfffde:8	; D/A 1 output enable
; A/D: fffe8=ctrl
	bset	#0x0,@0xfffe8:8	; select A/D 1

boucle:
	bset	#5,@0xfffe8:8	; A/D start conversion
cv:	btst	#7,@0xfffe8:8	; conversion finished ?
	beq	cv	; branch while bit Z=0 ie adf=0
	mov.b	@0xfffe8:8,r0l  ; reads ADCSR (?! ... p. 533)
	bclr	#7,@0xfffe8:8 ; datum read: ADF=0
	mov.b	@0xfffe2:8,r1l  ; read ADDRB=datum hi (lo in fffe1) for A/D1
	
	mov.b	r1l,@0xfffdd:8	; value of D/A 1
	; inc r1l:8
	jmp 	boucle

	.end
