/*************************************************************/
/* $B%b%H%m!<%i(BS$B%U%)!<%^%C%HJQ49%W%m%0%i%`(B                     */
/*    S3 --> S2                                              */
/*       1998/09/09  H.Namikata                              */
/*************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define LF 10
#define CR 13
#define TRUE 1
#define FALSE 0
#define MAX_STRING_LEN 1024
#define MAX_DATA 256

struct sform {
  int type;
  int num;
  unsigned int addr;
  unsigned int data[MAX_DATA];
  unsigned int sum;
};

/***************************************************/
/* $B%U%!%$%k$+$i#19T<h$j=P$9(B                        */
/***************************************************/
int getline(char *s, int n, FILE *f)
{
  register int i=0;

  n--;
  while(1) {
    s[i] = (char)fgetc(f);
    
    if(s[i] == CR)
      s[i] = fgetc(f);

    if( (s[i] == LF)||(s[i]==EOF)||(i == n)) {
      s[i] = '\0';
      break;
    }
    i++;
  }
  return (feof(f) ? 1 : 0);
}

/*************************************************/
/* 2$B$N$Y$->h$r7W;;$9$k(B                             */
/*************************************************/
int pow2(int num)
{
  int i,j;

  j = 1;
  for(i=0;i<num;i++) j *= 2;
  return j;
}

/***************************************************/
/* 16$B?J$NJ8;z$r?t;z$KD>$9(B                          */
/***************************************************/
int axtoi(char str[])
{
  int i,len,tmp,ans;
  
  ans = 0;
  len = strlen(str);
  for(i=0;i<len;i++) {
    if( ( 'A'<=toupper(str[len-i-1]) ) && (toupper(str[len-i-1])<='F')) {
      tmp =  (int)toupper(str[len-i-1]) - (int)'A' + 10 ;
    } else { 
      if( ( '0'<=str[len-i-1] ) && (str[len-i-1]<='9')) {
	tmp =  (int)str[len-i-1] - (int)'0' ;
      } 
      else 
	{
	  return -1;
	}
    }
    if( ( tmp < 0) || (tmp > 16) ) return -1;
    ans += tmp * pow2(i*4);
  }
  return ans;
}
  
/***************************************************/
/* $BJ8;zNs$+$i%G!<%?$r<h$j=P$9!#(B                    */
/***************************************************/
struct sform get_s_data(char *str)
{
  struct sform data;
  char *p;
  char buf[256];
  int tmp,i,j;

  p = str;
  data.type=data.num=data.addr=data.sum=0;
  while(isspace(*p)) p++;    /* $B6uGrJ8;z$rFI$_Ht$P$9!#(B    */
  if(toupper(*p) != 'S') {          /* $B:G=i$,(B'S'$B=P$J$$$J$i%(%i!<(B */
    data.type = -1;
    return data;
  }
  p++;
  
  if((*p < '0')||(*p > '9')) {  /* $B%G!<%?%?%$%W$N<hF@(B */
    data.type = -1;
    return data;
  }
  data.type = (int)*p - (int)'0';
  p++;

  for(i=0;i<2;i++) buf[i] = *p++;  /* $B%G!<%?%P%$%H?t$N<hF@(B */
  buf[i] = '\0';
  if((data.num=axtoi(buf)) == -1) {
    data.type = -1;
    return data;
  }

  switch(data.type) {               /* $B%"%I%l%9$H%G!<%?$H%A%'%C%/%5%`$N<hF@(B */
  case 0:                             /* S0 $B%U%#!<%k%I(B */
    for(j=0;j<data.num-1;j++) {       /* $B%G!<%?$N<hF@(B */
      for(i=0;i<2;i++) buf[i] = *p++;
      buf[i] = '\0';
      if((data.data[j]=axtoi(buf)) == -1) {
	data.type = -1;
	return data;
      }
    }
    data.data[data.num-1] = -1;

    for(i=0;i<2;i++) buf[i] = *p++;   /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    data.addr = -1;
    return data;
    break;
  case 1:                             /* S1 $B%U%#!<%k%I(B */
    for(i=0;i<4;i++) buf[i] = *p++;   /* $B%"%I%l%9$N<hF@(B */
    buf[i] = '\0';
    if((data.addr=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    for(j=0;j<data.num-3;j++) {       /* $B%G!<%?$N<hF@(B */
      for(i=0;i<2;i++) buf[i] = *p++;
      buf[i] = '\0';
      if((data.data[j]=axtoi(buf)) == -1) {
	data.type = -1;
	return data;
      }
    }
    data.data[data.num-3] = -1;
    for(i=0;i<2;i++) buf[i] = *p++;   /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    return data;
    break;
  case 2:                                /* S2 $B%U%#!<%k%I(B */
    for(i=0;i<6;i++) buf[i] = *p++;      /* $B%"%I%l%9$N<hF@(B */
    buf[i] = '\0';
    if((data.addr=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    for(j=0;j<data.num-4;j++) {       /* $B%G!<%?$N<hF@(B */
      for(i=0;i<2;i++) buf[i] = *p++;
      buf[i] = '\0';
      if((data.data[j]=axtoi(buf)) == -1) {
	data.type = -1;
	return data;
      }
    }
    data.data[data.num-4] = -1;
    for(i=0;i<2;i++) buf[i] = *p++;   /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
printf("Not sum\n");
      return data;
    }
    return data;

    break;
  case 3:                               /* S3 $B%U%#!<%k%I(B */
    for(i=0;i<8;i++) buf[i] = *p++;
    buf[i] = '\0';
    if((data.addr=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    for(j=0;j<data.num-5;j++) {       /* $B%G!<%?$N<hF@(B */
      for(i=0;i<2;i++) buf[i] = *p++;
      buf[i] = '\0';
      if((data.data[j]=axtoi(buf)) == -1) {
	data.type = -1;
	return data;
      }
    }
    data.data[data.num-5] = -1;
    for(i=0;i<2;i++) buf[i] = *p++;   /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    return data;

    break;
  case 7:                            /* S7 $B%U%#!<%k%I(B */
    for(i=0;i<8;i++) buf[i] = *p++;  /* $B%"%I%l%9$N<hF@(B */
    buf[i] = '\0';
    if((data.addr=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    for(i=0;i<2;i++) buf[i] = *p++; /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    data.data[0] = -1;
    return data; 
    break;
  case 8:                             /* S8$B%U%#!<%k%I(B */
    for(i=0;i<6;i++) buf[i] = *p++;   /* $B%"%I%l%9$N<hF@(B */
    buf[i] = '\0';
    if((data.addr=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    for(i=0;i<2;i++) buf[i] = *p++;   /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    data.data[0] = -1;
    return data; 
    break;
  case 9:                               /* S9$B%U%#!<%k%I(B */
    for(i=0;i<4;i++) buf[i] = *p++;     /* $B%"%I%l%9$N<hF@(B */
    buf[i] = '\0';
    if((data.addr=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    for(i=0;i<2;i++) buf[i] = *p++;      /* $B%A%'%C%/%5%`$N<hF@(B */
    buf[i] = '\0';
    if((data.sum=axtoi(buf)) == -1) {
      data.type = -1;
      return data;
    }
    data.data[0] = -1;
    return data; 
    break;
  default:
    data.type = -1;
    return data;
  }
}

/******************************************************/
/* $B%U%)!<%^%C%H$rJQ$($F=PNO(B S3->S2 S7->S8             */
/******************************************************/
void change_format(struct sform data,FILE *fo)
{
  int i;
  unsigned int sum;

  switch(data.type) {
  case -1:
    fprintf(stderr,"Not S format file !\n");
    exit(1);
    break;
  case 0:
  case 1:
  case 9:
    fprintf(fo,"S%01d",data.type);
    fprintf(fo,"%02X",data.num);
    if(data.addr != -1) fprintf(fo,"%04X",data.addr);
    for(i=0;data.data[i] != -1;i++) {
      fprintf(fo,"%02X",data.data[i]);
    }
    fprintf(fo,"%02X\n",data.sum);
    break;
  case 2:
  case 8:
    fprintf(fo,"S%01d",data.type);
    fprintf(fo,"%02X",data.num);
    if(data.addr != -1) fprintf(fo,"%06X",data.addr);
    for(i=0;data.data[i] != -1;i++) {
      fprintf(fo,"%02X",data.data[i]);
    }
    fprintf(fo,"%02X\n",data.sum);
    break;
  case 3:
    fprintf(fo,"S2");
    fprintf(fo,"%02X",data.num-1);
    if(data.addr != -1) fprintf(fo,"%06X",data.addr);
    sum = 0;
    for(i=0;data.data[i] != -1;i++) {
      fprintf(fo,"%02X",data.data[i]);
      sum += (unsigned int)data.data[i];
    }
    sum +=  data.num - 1  + ((data.addr >> 24)&0xff)
      + ((data.addr >> 16)&0xff ) 
	+ ((data.addr >> 8)&0xff) +  ((data.addr)&0xff) ;
    sum = ~sum & 0xff; 
    fprintf(fo,"%02X\n",sum);
    break;
  case 7:
    fprintf(fo,"S8");
    fprintf(fo,"%02X",data.num-1);
    if(data.addr != -1) fprintf(fo,"%06X",data.addr);
    for(i=0;data.data[i] != -1;i++) {
      fprintf(fo,"%02X",data.data[i]);
    }
    sum =  data.num - 1  + ((data.addr >> 24)&0xff)
      + ((data.addr >> 16)&0xff ) 
	+ ((data.addr >> 8)&0xff) +  ((data.addr)&0xff) ;
    sum = ~sum & 0xff; 
    fprintf(fo,"%02X\n",sum);
    break;
  default:
    fprintf(stderr,"Not S format file !\n");
    exit(1);
    break;
  }
}




int main(int argc,char *argv[])
{
  char outfile[MAX_STRING_LEN],buf[MAX_STRING_LEN];
  FILE *fi,*fo;
  struct sform data;
  int i,mvflag=0;

  if( (argc != 2) && (argc != 3)) {   /* $B%*%W%7%g%s$N2r@O(B */
    fprintf(stderr,"Usage : %s infile [outfile]\n",argv[0]);
    exit(1);
  }
  if(argc == 2) {
    strcpy(outfile,"tmpS3to2.$$");
    mvflag = 1;
  } else {
    strcpy(outfile,argv[2]);
    mvflag = 0;
  }

  if((fi = fopen(argv[1],"r"))==NULL) {
    fprintf(stderr,"File %s not exist.\n",argv[1]);
    exit(1);
  }
  if((fo = fopen(outfile,"w"))==NULL) {
    fprintf(stderr,"File %s cannot write.\n",outfile);
    exit(1);
  }

  while(!getline(buf,sizeof(buf),fi)) {  /* $BJQ493+;O(B */
    data = get_s_data(buf);
    change_format(data,fo);
  }

 if(mvflag) {
    rename(outfile,argv[1]);
  }
  return 0;
}
