/*
   H8/3048F Bootstrap EEPROM Programming
*/

#include "h83048addr.h"

int sgetch(void);
void sputch(int ch);

char buf[]="Hello,world\n";

int main(void)
{
    unsigned char ch;
    int i;

    *(volatile char*)(SMR1)=0;
    *(volatile char*)(BRR1)=51;
    *(volatile char*)(SCR1)|=0x30;

    ch=0;
    *(volatile char*)(PBDDR)=0xff;
    while(1){
	for(i=0;buf[i];i++){
	    sputch(buf[i]);
	}
	*(volatile char*)(PBDR)=0xff;
	sputch(ch++);
	*(volatile char*)(PBDR)=0x00;
    }
}

int sgetch(void)
{
    unsigned char ch;
    while(!(IOREG(SSR1)&0x40));
    ch=IOREG(RDR1);
    IOREG(SSR1)&=~0x40;
    return (int)ch;
}

void sputch(int ch)
{
    while(!(IOREG(SSR1)&0x80));
    IOREG(TDR1)=ch;
    IOREG(SSR1)&=~0x80;
}

#pragma interrupt
void int_adi(void)
{
}
















