        .h8300h
        .section            .vect
        .global             _vector_table

_vector_table:
        .long _start        ; 0 reset vector
        .long _catch_e_1    ; 1 reserved vector
        .long _catch_e_2    ; 2 reserved vector
        .long _catch_e_3    ; 3 reserved vector
        .long _catch_e_4    ; 4 reserved vector
        .long _catch_e_5    ; 5 reserved vector
        .long _catch_e_6    ; 6 reserved vector
        .long _catch_e_7    ; 7 nmi vector
        .long _catch_e_8    ; 8 trapa 0 vector
        .long _catch_e_9    ; 9 trapa 1 vector
        .long _catch_e_10   ; 10 trapa 2 vector
        .long _catch_e_11   ; 11 trapa 3 vector
        .long _catch_e_12   ; 12 irq0 vector ipra7
        .long _catch_e_13   ; 13 irq1 vector ipra6
        .long _catch_e_14   ; 14 irq2 vector ipra5
        .long _catch_e_15   ; 15 irq3 vector
        .long _catch_e_16   ; 16 irq4 vector ipra4
        .long _catch_e_17   ; 17 irq5 vector
        .long _catch_e_18   ; 18 reserved vector
        .long _catch_e_19   ; 19 reserved vector
        .long _catch_e_20   ; 20 wovi wdt vector ipra3
        .long _catch_e_21   ; 21 cmi ref cont vector
        .long _catch_e_22   ; 22 reserved vector
        .long _catch_e_23   ; 23 reserved vector
        .long _catch_e_24   ; 24 imia0 itu0 vector ipra2
        .long _catch_e_25   ; 25 imib0 vector
        .long _catch_e_26   ; 26 ovi0 vector
        .long _catch_e_27   ; 27 reserved vector
        .long _catch_e_28   ; 28 imia1 itu1 vector ipra1
        .long _catch_e_29   ; 29 imib1 vector
        .long _catch_e_30   ; 30 ovi1 vector
        .long _catch_e_31   ; 31 reserved vector
        .long _catch_e_32   ; 32 imia2 itu2 vector ipra0
        .long _catch_e_33   ; 33 imib2 vector
        .long _catch_e_34   ; 34 ovi2 vector
        .long _catch_e_35   ; 35 reserved vector
        .long _catch_e_36   ; 36 imia3 itu3 vector iprb7
        .long _catch_e_37   ; 37 imib3 vector
        .long _catch_e_38   ; 38 ovi3 vector
        .long _catch_e_39   ; 39 reserved vector
        .long _catch_e_40   ; 40 imia4 itu4 vector iprb6
        .long _catch_e_41   ; 41 imib4 vector
        .long _catch_e_42   ; 42 ovi4 vector
        .long _catch_e_43   ; 43 reserved vector
        .long _catch_e_44   ; 44 dend0a dmac vector iprb5
        .long _catch_e_45   ; 45 dend0b vector
        .long _catch_e_46   ; 46 dend1a vector
        .long _catch_e_47   ; 47 dend1b vector
        .long _catch_e_48   ; 48 reserved vector -----
        .long _catch_e_49   ; 49 reserved vector
        .long _catch_e_50   ; 50 reserved vector
        .long _catch_e_51   ; 51 reserved vector
;        .long _catch_e_52   ; 52 eri0 sci0 vector iprb3
;        .long _catch_e_53   ; 53 rxi0 vector
;        .long _catch_e_54   ; 54 txi0 vector
        .long _sci0_rcv_isr ; 52 eri0 sci0 vector iprb3
        .long _sci0_rcv_isr ; 53 rxi0 vector
        .long _sci0_xmt_isr ; 54 txi0 vector
        .long _catch_e_55   ; 55 tei0 vector
        .long _catch_e_56   ; 56 eri1 sci1 vector iprb2
        .long _catch_e_57   ; 57 rxi1 vector
        .long _catch_e_58   ; 58 txi1 vector
        .long _catch_e_59   ; 59 tei1 vector
        .long _catch_e_60   ; 60 adi a/d vector iprb1
        .long _catch_e_61   ; 61 free vector
        .long _catch_e_62   ; 62 free vector
        .long _catch_e_63   ; 63 free vector
