/* Operating system stubs, set up for the MRI simulator */

#include <_ansi.h>
#include <sys/types.h>
#include <sys/stat.h>


int _DEFUN(_read,(file, ptr, len),
	   int file _AND
	   char *ptr _AND
	   int len)
{
        unsigned char *ssr;
        char *rdr;

	if(file == 0) {
        	rdr = (unsigned char *)0xffffbd;
        	ssr = (unsigned char *)0xffffbc;
	} else {
        	rdr = (unsigned char *)0xffffbd;
        	ssr = (unsigned char *)0xffffbc;
	}
	while( !(*ssr & 0x78 )) { _dmy_write();}     /* Wait somewhere flag O */
 	switch( *ssr & 0x40 )                      /* Check receive flag  */
 	{
	case 0x40:                                  /* Receive complete */
		*ptr = *rdr;
		*ssr = (~0x40) & (*ssr) ; /* Clear receive data flag      */
		break ;
	default:                            /* Occur eceive error   */
		*ssr = 0x80 ; /* Clear receive error flag */
		ptr[0] = '\0';
		return 0;
	}  

	return 1;
}


int _DEFUN(_lseek,(file, ptr, dir),
	  int file _AND
	  int ptr _AND
	  int dir)
{
  return 0;
}

int _DEFUN(_close,(file),
	  int file)
{
  return -1;
}

int isatty(file)
     int file;
{
  return 1;
}

int _DEFUN(_fstat,(file, st),
	  int file _AND
	  struct stat *st)
{
  st->st_mode = S_IFCHR;
  return 0;
}

int
_open (path, flags)
     const char *path;
     int flags;
{
  return 0;
}
