; 18/6/01: OK in 4 bits mode
	.h8300h
        .align 1
        .global _start

_start:
	mov.l	#0xffefc,er7
	MOV.B	#0x00,r0l	
	MOV.B	r0l,@0xfffc1	
	MOV.B	r0l,@0xfffC5	; SW port as input

	MOV.B	#0xff,r0l	
	MOV.B	r0l,@0xfffd8	
	MOV.B	r0l,@0xfffC4	
	MOV.B	r0l,@0xfffDa	
	MOV.B	r0l,@0xfffC8

	JSR	DELAI		;15ms
	
	MOV.B	#0b00100011,r0l	; 4 bit mode
	JSR	@dlcd_4
	MOV.B	#0b00100011,r0l	;  4 bit mode
	JSR	@dlcd_4
	MOV.B	#0b00100011,r0l	;  4 bit mode
	JSR	@dlcd_4
	MOV.B	#0b00100010,r0l	; set 4 bit operations 
	JSR	@dlcd_4

	MOV.B	#0b00101000,r0l	; 11.1/2: 00101000 in 8 bit mode
	jsr	sndcmd8		;           4 bits, 2 lines, 5x8 dots font
	MOV.B	#0b00001000,r0l	; 13.1/2: 00001000 in 8 bit mode
	jsr	sndcmd8                     disp. off, curs. off, blink off
	MOV.B	#0b00001110,r0l	; 15.1/2: 00001111 in 8 bit mode
	jsr	sndcmd8                     disp. on, curs. on, blink off
	MOV.B	#0b00000110,r0l	; 17.2	; 00000110 in 8 bit mode
	jsr	sndcmd8                     inc. curs. pos., no disp. shift

	;MOV.B	#0x61,r0l  	; display a char: 'a'
	;JSR	@snddat8

	MOV.B	#11,r2l		; display string top-left
	mov.l	#MOJI,er3
SYOKI0:	MOV.B	@er3+,r0l
	jsr	@snddat8
	DEC.B	r2l
	BNE	SYOKI0		

	MOV.B	#0b11000100,r0l	; gotoxy (2nd line): pos 44
	jsr	sndcmd8

	MOV.B	#11,r2l		; display string bottom-right
	mov.l	#MOJI,er3
SYOKI02:MOV.B	@er3+,r0l
	jsr	@snddat8
	DEC.B	r2l
	BNE	SYOKI02		

	sleep
;jmf:	jmp jmf		; infinite loop ...

snddat8:		; send 8 bits data (!= cmds)
	mov.b	r0l,r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
	AND.B   #0x0F,r1l:8
				
	MOV.B	r1l,@0xfffC6:8
	BSET	#4,@0xfffC6:8	; RS=0 -> 1 (datum)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00	
	BCLR	#5,@0xfffC6:8
	JSR	@time00	

	mov.b	r0l,r1l:8
	AND.B	#0x0F,r1l:8
	MOV.B	r1l,@0xfffC6:8
	BSET	#4,@0xfffC6:8	; RS=0 -> 1 (datum)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00
	BCLR	#5,@0xfffC6:8	
	JSR	@time00
	RTS

DELAI:  mov.w   #0x002f, r4 
WAI1:   mov.w   #0x4fff, r5 
WAI:    dec.w   #1, r5 ; Program
        bpl     WAI
        dec.w   #1, r4
        bpl     WAI1
        rts

sndcmd8:		; send 8 bits data (!= cmds)
	mov.b	r0l,r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
	AND.B   #0x0F,r1l:8
				
	MOV.B	r1l,@0xfffC6:8
	BCLR	#4,@0xfffC6:8	; RS-> 0 (cmd)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00	
	BCLR	#5,@0xfffC6:8
	JSR	@time00	

	mov.b	r0l,r1l:8
	AND.B	#0x0F,r1l:8
	MOV.B	r1l,@0xfffC6:8
	BCLR	#4,@0xfffC6:8	; RS=0 (cmd)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00
	BCLR	#5,@0xfffC6:8	
	JSR	@time00
	RTS

;-----4mS-----
time00:	PUSH.L	er0
	mov.l	#0x2000,er0
time01:	SUB.L	#1,er0
	BNE	time01
	POP.L	er0
	RTS

dlcd_4:	MOV.B	r0l,@0xfffC6:8
	JSR	@time00		
	BCLR	#5,@0xfffC6:8	; RS -> 0
	BSET    #4,@0xfffC6:8	; E=hi
 	JSR	@time00
	RTS
 
	.align 1
MOJI:	;.data.b   0x48,0x65,0x6c,0x6c,0x6f,0x20,0x57,0x6f,0x72,0x6c,0x64
	.string "Hello World"
	.end	                     ; Hello World
