; cat < /dev/ttyS0 ds term1 ; cat > /dev/ttyS0 ds term2 ou` on ecrit

	.h8300h
;	.section .start
	.align 1
	.global _start

_start: mov.l   #0xffefc,er7    ; =mov.l ...,sp : set stack pointer

        mov.b   #0xff,r0l                ; set P5 as output
        mov.b   r0l,@0xfffc8             ; |

	bset	#4,@0xfffba:8	; SCI initialization: receive ena
	bset	#5,@0xfffba:8	; |		      transmit ena
	mov.w	#0xff00,r0	; |
	mov.b	r0h,@0xfffd4:24	; |

	mov.l	#rcvint,er0:32
	mov	er0,@0x000e4:32; RXI1 interrupt vector
	; mov	er0,@0xff400:32; RXI1 interrupt vector
;	bset	#6,@0xfffba:8	; SCI init: receive irq ena

; ena_int:andc.b  #0x7f, ccr      ; Enable the CCR interupt flag

	bsr	rcv
	mov	@0x000e4,er2:32
	; mov	@0xff400,er2:32
	bsr	snd

attend:	; sleep
	bra	attend

rcvint:
        mov.b   @0xfffbd:8,r2l
        bclr    #6,@0xfffbc:8

        bset    #0,@0xfffca:8   ; P5DR et C8 -> FF pour out:
        bsr     DELAI
        bclr    #0,@0xfffca:8   ; P5DR et C8 -> FF pour out:

	rte

DELAI:  mov.w   #0x002f, r4 ; Set program loop counter mais 1f ne marche pas
WAI1:   mov.w   #0x4fff, r5 ; Set program loop counter     8fff
WAI:    dec.w   #1, r5 ; Program
        bpl     WAI
        dec.w   #1, r4
        bpl     WAI1
	rts

snd: 	btst    #7,@0xfffbc:8
        beq     snd
        mov.b   r2l,@0xfffbb:8
	bclr    #7,@0xfffbc:8
	rts

rcv:	btst    #6,@0xfffbc:8
      	beq    	rcv
        mov.b   @0xfffbd:8,r2l
        bclr    #6,@0xfffbc:8
	rts

	.end
