#include "init.h"
#include "h8stub.h"
#include "sci.h"

#define enable_ints()   asm(" andc #0x3F,ccr")
#define disable_ints()  asm(" orc  #0xC0,ccr")

int main(void)
{
  int ch;

  init();

  InitGDBStub();

  gdb_console_puts("Initializing H8/300H SCI-0\n\r");

  sci0_init(BAUD(9600), SCI_8N1);

  enable_ints();

  sci0_puts("\n\n\r"
            "H8/300H Echo Test.\n\r");

  for (;;)
    {
    while ((ch = sci0_getc()) < 0)
      continue;

    sci0_putc(ch);
    }

  return -1;
}
